Package org.bukkit.block

# Enum Class BlockSupport

java.lang.Object
java.lang.Enum<BlockSupport>
org.bukkit.block.BlockSupport

All Implemented Interfaces:
  `Serializable`, `Comparable<BlockSupport>`, `Constable`

public enum BlockSupport extends Enum<BlockSupport>
Represents a level of support a block can give on one of its faces.

Any given face on a block may support anywhere between none and all three of the values in this enum. The top face of a grass block for instance can support blocks that require a full, center, or rigid face. On the contrary, all sides except the bottom of a camp fire cannot support any blocks, while the bottom face can support blocks that require a full or center face (such as a ceiling button).

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CENTER`
The face is capable of supporting blocks towards the center.
`FULL`
The face is treated as a full block.
`RIGID`
The face is capable of supporting fragile blocks such as rails.

## Method Summary

Modifier and Type
Method
Description
`static BlockSupport`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static BlockSupport[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### FULL

public static final BlockSupport FULL
The face is treated as a full block. For example, the side of a stair is not a full face and cannot support a wall torch, whereas the back and bottom of a stair are considered full.

### CENTER

public static final BlockSupport CENTER
The face is capable of supporting blocks towards the center. For example, a wall or a fence post can support a standing torch as there is a solid component in the middle of the block.

### RIGID

public static final BlockSupport RIGID
The face is capable of supporting fragile blocks such as rails. Most full-supportable top faces are rigid, unlike walls and posts, or the side of a stone block, none of which are rigid.

## Method Details

### values

public static BlockSupport[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static BlockSupport valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null